class ClawsFire2 extends KFMeleeFire;

var float ZoomLevel;

function float MaxRange()
{
    if (Instigator.Region.Zone.bDistanceFog)
        TraceRange = FClamp(Instigator.Region.Zone.DistanceFogEnd, 125, default.TraceRange);
    else
        TraceRange = default.TraceRange;

    return TraceRange;
}

function ModeTick(float deltaTime)
{
  local PlayerController C;
  ZoomLevel += deltaTime;
  if (ZoomLevel > 0.10)
    ZoomLevel = 0.10;
  C = PlayerController(Instigator.Controller);
  if(C != None)
    C.DesiredFOV = FClamp(90.0 - (ZoomLevel * 88.0), 1, 170);
}

simulated function vector GetFireStart(vector X, vector Y, vector Z)
{
    return Instigator.Location;
}

function StartBerserk()
{
}

function StopBerserk()
{
}

function StartSuperBerserk()
{
}

function DoFireEffect()
{
    local Vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
    local Rotator Aim;
    local Actor Other;
    local float Scale, Damage, Force;
    local float LifeSap;
    local float LifeSapMultiplier;

    Instigator.MakeNoise(1.0);
    Weapon.GetViewAxes(X,Y,Z);
    bAutoRelease = false;
    LifeSapMultiplier = 1.0;

    if ( (AutoHitPawn != None) && (Level.TimeSeconds - AutoHitTime < 0.15) )
    {
        Other = AutoHitPawn;
        HitLocation = Other.Location;
        AutoHitPawn = None;
    }
    else
    {
        StartTrace = Instigator.Location;
        Aim = AdjustAim(StartTrace, AimError);
        EndTrace = StartTrace + ShieldRange * Vector(Aim);
        Other = Weapon.Trace(HitLocation, HitNormal, EndTrace, StartTrace, true);
    }

    Scale = (FClamp(HoldTime, MinHoldTime, FullyChargedTime) - MinHoldTime) / (FullyChargedTime - MinHoldTime); // result 0 to 1
    Damage = MinDamage + Scale * (MaxDamage - MinDamage);
    Force = MinForce + Scale * (MaxForce - MinForce);

    Instigator.AmbientSound = None;
    Instigator.SoundVolume = Instigator.Default.SoundVolume;

    if (ChargingEmitter != None)
        ChargingEmitter.mRegenPause = true;

    if ( Other != None && Other != Instigator )
    {

        LifeSap = (0 - (MinDamage + MaxDamage ) * (LifeSapMultiplier) );

        if ( Pawn(Other) != None || (Decoration(Other) != None && Decoration(Other).bDamageable) )
           {
            Other.TakeDamage(Damage, Instigator, HitLocation, Force*(X+vect(0,0,0.5)), DamageType);

            if (Instigator.Health < Instigator.HealthMax)
              {
               Instigator.TakeDamage (LifeSap, Instigator, HitLocation, Force*(X+vect(0,0,0.5)), DamageType) ;
               
                 if (Instigator.Health > Instigator.HealthMax )
                  {
                    Instigator.Health = Instigator.HealthMax;
                  }

              }

           }

                else
          {
            if ( xPawn(Instigator).bBerserk )
                Force *= 2.0;
            Instigator.TakeDamage(MinSelfDamage+SelfDamageScale*Damage, Instigator, HitLocation, -SelfForceScale*Force*X, DamageType);
            if ( DestroyableObjective(Other) != None )
                Other.TakeDamage(Damage, Instigator, HitLocation, Force*(X+vect(0,0,0.5)), DamageType);
          }
    }

    SetTimer(0, false);
}

defaultproperties
{
     ShieldRange=125.000000
     MinForce=.200000
     MaxForce=.500000
     MinDamage=10.000000
     MaxDamage=15.000000
     SelfForceScale=0.000000
     SelfDamageScale=0.000000
     MinSelfDamage=0.000000
     ChargingSoundVolume=0
     bFireOnRelease=False
     FireSound=Sound'KFWeaponSound.ZombieChop'
     FireRate=.500000
     DamageType=Class'KFmod.DamTypeClaws'
     AimError=0
     BotRefireRate=.5
}

