class CrossbowArrow extends Projectile;

var ONSBluePlasmaFireEffect ShockBallEffect;
var float DamageAtten;

var float LastSparkTime;
var byte Bounces;
var class<xEmitter> HitEffectClass;
var() float DampenFactor, DampenFactorParallel;
var class<xEmitter> ArrowTrailClass;
var xEmitter ArrowTrail;
var vector InitialLocation;
var Actor IgnoreActor;

// Sounds
var sound Arrow_hitwall[3];
var sound Arrow_rico[2];
var sound Arrow_hitarmor;
var sound Arrow_hitflesh;

var Vector tempStartLoc;

simulated event PreBeginPlay()
{
    Super.PreBeginPlay();

    if( Pawn(Owner) != None )
        Instigator = Pawn( Owner );
}

replication
{
    reliable if (Role == ROLE_Authority)
        IgnoreActor, Bounces, InitialLocation;
}

simulated function PostBeginPlay()
{
    local float r;

    InitialLocation = Location;
    Velocity = Vector(Rotation) * (Speed);
    if (PhysicsVolume.bWaterVolume)
        Velocity *= 0.65;

    r = FRand();
    if (r > 0.75)
        Bounces = 2;
    else if (r > 0.25)
        Bounces = 1;
    else
        Bounces = 0;

    settimer(1.0, true);
    Super.PostBeginPlay();
    if ( Instigator != None )
		InstigatorController = Instigator.Controller;
}

simulated function PostNetBeginPlay()
{
	local PlayerController PC;

	Super.PostNetBeginPlay();

	if ( Level.NetMode == NM_DedicatedServer )
		return;

	PC = Level.GetLocalPlayerController();
	if ( (Instigator != None) && (PC == Instigator.Controller) )
		return;
	if ( Level.bDropDetail || (Level.DetailMode == DM_Low) )
	{
		bDynamicLight = false;
		LightType = LT_None;
	}
	else if ( (PC == None) || (PC.ViewTarget == None) || (VSize(PC.ViewTarget.Location - Location) > 3000) )
	{
		bDynamicLight = false;
		LightType = LT_None;
	}
}

simulated function Destroyed()
{
    if (ShockBallEffect != None)
    {
		if ( bNoFX )
			ShockBallEffect.Destroy();
		else
			ShockBallEffect.Kill();
	}

	Super.Destroyed();
}

simulated function Timer()
{
   Velocity = Velocity * 0.8;
   speed = VSize(Velocity);
   if ( speed < 7000 )
   {
        bBounce=True;
   }
}

simulated function DestroyTrails()
{

}

simulated function PhysicsVolumeChange( PhysicsVolume Volume )
{
    if (Volume.bWaterVolume)
    {
        Volume.PlayEntrySplash(self);  // water splash effects
        Velocity *= 0.85;           // travels slower in "water"
        if ( ArrowTrail != None )
            ArrowTrail.mRegen=false;
    }
}

simulated function Explode(vector HitLocation,vector HitNormal)
{
//Nada, zilch nien.
}

simulated function ProcessTouch (Actor Other, vector HitLocation)
{
    local name BoneName;
    local float dist;
    local int temp_damage; // use this to log so we can ensure the damage is correct.
    local Vector X, RefNormal, RefDir;

    if ( Other != none && Other != Instigator) // dont want to hit ourself :)
    {
        speed = VSize(Velocity);
        if ( speed > 200 )
        {
             // check to see if it was deflected
             if (Other != none && Other.IsA('xPawn') && xPawn(Other).CheckReflect(HitLocation, RefNormal, Damage*1))
             {
                 if (Role == ROLE_Authority)
                 {
                     X = Normal(Velocity);
                     RefDir = X - 2.0*RefNormal*(X dot RefNormal);
                     Spawn(Class, Other,, HitLocation+RefDir*20, Rotator(RefDir));
                 }
                 Destroy();
             }
             // play a sound of the arrow hitting the player
             if (Other != none && Pawn(Other).ShieldStrength != 0.0)
                  PlaySound(Arrow_hitarmor);   // implies hit a target with shield/armor
             else
                  PlaySound(Arrow_hitflesh);  // implies hit a target with w/o shield/armor

             if (Other != none && other.IsA('xPawn'))   // find if we are an xpawn or some other type of pawn
             {
                  // Get the closed "bone" that we hit in the model
                   xPawn(other).CalcHitLoc(Hitlocation, Normal(Velocity), boneName, dist);
                   BoneName= xPawn(other).GetClosestBone(HitLocation, Normal(Velocity), dist);
                   // check to see if we hit the head
                   if ( Role == ROLE_Authority )
                   {
                        if (BoneName == 'Bip01 Head')
                        {
                            // its a head shoot so do more damage
                            temp_damage = temp_damage *1;
                            //now we need to see if its a killing head shot
                            if ( Pawn(other) != none  && temp_damage  > Pawn(other).Health)
                            {
                                if (!Level.Game.bTeamGame || (Pawn(Other).PlayerReplicationInfo != None && Instigator.PlayerReplicationInfo != None
                                && Pawn(Other).PlayerReplicationInfo.Team !=Instigator.PlayerReplicationInfo.Team ) )
                                {
                                     if ( Instigator == None || Instigator.Controller == None )
				                          Other.SetDelayedDamageInstigatorController( InstigatorController );
                                }
                            }
                        }
                        else   // normal damage as arrow did not hit the head
                             Other.TakeDamage( Damage, Instigator, HitLocation, MomentumTransfer * Normal(Velocity), MyDamageType);

                    }
                    if (Pawn(other) != none && bonename != '' )
                    {
                     //blah
                    }
                }
                else
                {                          // normal damage for pawns that are not xpawns..like proxies :)
                  if ( Role == ROLE_Authority )
                       other.TakeDamage( temp_damage, Instigator, HitLocation,MomentumTransfer * Normal(Velocity), MyDamageType);
                }
                Destroy();
        }
        else
        {
         //nada
        }
    }
}

simulated function PawnBaseDied()
{
	Destroy();
}

simulated function HitWall( vector HitNormal, actor Wall )
{
      local Vector VNorm;

      if(Level.NetMode != NM_DedicatedServer)
        Spawn(class'KFHitEffect');

      speed = VSize(Velocity);
	  if ( Role == ROLE_Authority )
	  {
		 if ( !Wall.bStatic && !Wall.bWorldGeometry )
		 {
			if ( Instigator == None || Instigator.Controller == None )
				Wall.SetDelayedDamageInstigatorController( InstigatorController );
			Wall.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), MyDamageType);
            HurtWall = Wall;
		 }
		 MakeNoise(1.0);
	  }
      if ( speed > 7000 )
      {    // going fast enough to stick into wall
          PlaySound(Arrow_hitwall[Rand(3)],,2.5*TransientSoundVolume);
          // Turn off effects
          AmbientSound=None;
          MakeNoise(0.3);
          LifeSpan=10.0;
          settimer(0.0,false);
          // Stick to a vehicle here or stop it from moving here
          if (wall != none && Vehicle(Wall) != None)
          {
             Stick(Wall, Location);
             return;
          }
          else
          {
             SetPhysics(PHYS_None);
             SetCollision(false,false,false);
          }
      }
      else if ( Speed < 10 )
      {                           // arrow/bolt not moving any more stop it
          bBounce = False;
          SetPhysics(PHYS_None);
          settimer(0.0,false);
          if ( ArrowTrail != None )
          {
        	ArrowTrail.mRegenPause = True;
        	ArrowTrail.LifeSpan = 1.0;
          }
      }
      else
      {
          bBounce=True;
          // Reflect off Wall w/damping
          VNorm = (Velocity dot HitNormal) * HitNormal;
          Velocity = -VNorm * DampenFactor + (Velocity - VNorm) * DampenFactorParallel;

		  if ( (Level.NetMode != NM_DedicatedServer) && (Speed > 250) )
			       PlaySound(Arrow_rico[Rand(2)], SLOT_Misc);
          if ( !Level.bDropDetail && (Level.DetailMode != DM_Low) && (Level.TimeSeconds - LastSparkTime > 0.5) && EffectIsRelevant(Location,false) )
          {
			 Spawn(HitEffectClass,,, Location, Rotator(HitNormal));
          }
    }
}

simulated function Landed(vector HitNormal)
{
	HitWall(HitNormal, None);
}

simulated function Stick(actor HitActor, vector HitLocation)
{
    LastTouched = HitActor;
    SetPhysics(PHYS_None);
    SetBase(HitActor);
    if (Base == None)
    {
    	UnStick();
    	return;
    }
    bCollideWorld = False;
    bProjTarget = true;
}

simulated function UnStick()
{
	Velocity = vect(0,0,0);
	IgnoreActor = Base;
	SetBase(None);
	SetPhysics(PHYS_Falling);
	bCollideWorld = true;
	bProjTarget = false;
	LastTouched = None;
}

simulated function BaseChange()
{
	if (!bPendingDelete && Physics == PHYS_None && Base == None)
		UnStick();
}

defaultproperties
{
     DamageAtten=5.000000
     DampenFactor=0.500000
     DampenFactorParallel=0.800000
     Arrow_hitwall(0)=Sound'KFWeaponSound.bullethitflesh2'
     Arrow_hitwall(1)=Sound'KFWeaponSound.bullethitflesh3'
     Arrow_hitwall(2)=Sound'KFWeaponSound.bullethitflesh4'
     Arrow_rico(0)=Sound'KFWeaponSound.bullethitmetal'
     Arrow_rico(1)=Sound'KFWeaponSound.bullethitmetal3'
     Arrow_hitarmor=Sound'KFWeaponSound.bullethitflesh4'
     Arrow_hitflesh=Sound'KFWeaponSound.bullethitflesh4'
     Speed=7200.000000
     MaxSpeed=7300.000000
     bSwitchToZeroCollision=True
     Damage=100.000000
     DamageRadius=0.000000
     MomentumTransfer=10000.000000
     MyDamageType=Class'KFmod.DamTypeCrossbow'
     ExplosionDecal=Class'KFmod.ShotgunDecal'
     DrawType=DT_StaticMesh
     StaticMesh=StaticMesh'KillingFloorStatics.XbowBolt'
     CullDistance=3000.000000
     LifeSpan=7.700000
     DrawScale=19.000000
     Style=STY_Alpha

}
