//=============================================================================
// Dualies Inventory class
//=============================================================================
class Dualies extends KFWeapon;

var name altFlashBoneName;
var name altTPAnim;
var Actor altThirdPersonActor;
var name altWeaponAttach;

function float GetAIRating()
{
	local Bot B;


	B = Bot(Instigator.Controller);
	if ( (B == None) || (B.Enemy == None) )
		return AIRating;

	return (AIRating + 0.00092 * FMin(800 - VSize(B.Enemy.Location - Instigator.Location),650));
}

function byte BestMode()
{
    return 0;
}

function bool RecommendRangedAttack()
{
	return true;
}

function float SuggestAttackStyle()
{
    return -0.7;
}

function AttachToPawn(Pawn P)
{
	local name BoneName;

	Super.AttachToPawn(P);

	if(altThirdPersonActor == None)
	{
	    altThirdPersonActor = Spawn(AttachmentClass,Owner);
	    InventoryAttachment(altThirdPersonActor).InitFor(self);
    }
    else
   		altThirdPersonActor.NetUpdateTime = Level.TimeSeconds - 1;
	BoneName = P.GetOffhandBoneFor(self);
	if(BoneName == '')
	{
	    altThirdPersonActor.SetLocation(P.Location);
	    altThirdPersonActor.SetBase(P);
	    log("OFFHANDBONEBROKE!");
    } else
    {
        if(!P.AttachToBone(altThirdPersonActor,BoneName))
            log("BONEATTACHBROKE!");
    }
    altThirdPersonActor.SetRelativeRotation(rot(0,32768,0));
    altThirdPersonActor.SetRelativeLocation(vect(10,-5,-5));

    if(altThirdPersonActor != None)
        DualiesAttachment(altThirdPersonActor).bIsOffHand = true;
    if(altThirdPersonActor != None && ThirdPersonActor != None)
    {
        DualiesAttachment(altThirdPersonActor).brother = DualiesAttachment(ThirdPersonActor);
        DualiesAttachment(ThirdPersonActor).brother = DualiesAttachment(altThirdPersonActor);
    } else
        log("DUALIES ATTACHMENT(S) UNABLE TO SPAWN",'KFError');
}

/*function AttachToPawn(Pawn P)
{
	if ( bDualMode )
	{
		BoneName = P.GetOffHandBoneFor(self);
		if ( BoneName == '' )
			return;
		if ( OffhandActor == None )
		{
			OffhandActor = AssaultAttachment(Spawn(AttachmentClass,Owner));
			OffhandActor.InitFor(self);
		}
		P.AttachToBone(OffhandActor,BoneName);
		if ( OffhandActor.AttachmentBone == '' )
			OffhandActor.Destroy();
		else
		{
			ThirdPersonActor.SetDrawScale(0.3);
			OffhandActor.SetDrawScale(0.3);
			OffhandActor.bDualGun = true;
			OffhandActor.TwinGun = AssaultAttachment(ThirdPersonActor);
			if ( Mesh == OldMesh )
			{
			    OffhandActor.SetRelativeRotation(rot(0,32768,0));
			    OffhandActor.SetRelativeLocation(vect(20,-10,-5));
			}
			else
			{
			    OffhandActor.SetRelativeRotation(rot(0,0,32768));
			    OffhandActor.SetRelativeLocation(vect(40,-3,-7));
			}
			AssaultAttachment(ThirdPersonActor).TwinGun = OffhandActor;
		}
	}
}   */

simulated function DetachFromPawn(Pawn P)
{
    Super.DetachFromPawn(P);
	if ( altThirdPersonActor != None )
	{
		altThirdPersonActor.Destroy();
		altThirdPersonActor = None;
	}
}

function Destroyed()
{
    Super.Destroyed();

    if(altThirdPersonActor != None)
        ThirdPersonActor.Destroy();
}

defaultproperties
{
     ClipCount=30
     ReloadRate=2.8
     ReloadBeginSound=Sound'KFWeaponSound.DeagleClipout'
     ReloadSound=Sound'KFWeaponSound.DeagleClipin'
     ReloadAnim="Reload"
     ReloadAnimRate=1.000000
     FireModeClass(0)=Class'KFmod.DualiesFire'
     FireModeClass(1)=class'KFmod.NoFire'
     PutDownAnim="PutDown"
     AIRating=0.400000
     CurrentRating=0.400000
     bShowChargingBar=True
     SelectSound=Sound'KFPlayerSound.getweaponout'
     OldCenteredOffsetY=0.000000
     OldPlayerViewOffset=(X=-8.000000,Y=5.000000,Z=-6.000000)
     OldSmallViewOffset=(X=4.000000,Y=11.000000,Z=-12.000000)
     OldPlayerViewPivot=(Pitch=400)
     OldCenteredRoll=3000
     Description="Big, and deadly"
     EffectOffset=(X=100.000000,Y=25.000000,Z=-10.000000)
     DisplayFOV=70.000000
     Priority=37
     SmallViewOffset=(X=13.000000,Y=12.000000,Z=-10.000000)
     CenteredOffsetY=-5.000000
     CenteredRoll=3000
     CenteredYaw=-1500
     InventoryGroup=2
     PickupClass=Class'KFmod.DeaglePickup'
     PlayerViewOffset=(X=4.000000,Y=5.500000,Z=-6.000000)
     PlayerViewPivot=(Pitch=400)
     BobDamping=8.000000
     AttachmentClass=Class'KFmod.DualiesAttachment'
     IconMaterial=Texture'KillingFloorHUD.Generic.HUD'
     IconCoords=(X1=250,Y1=110,X2=330,Y2=145)
     ItemName="Dual 9mms"
     LightType=LT_Pulse
     LightEffect=LE_NonIncidence
     LightHue=30
     LightSaturation=150
     LightBrightness=255.000000
     LightRadius=4.000000
     LightPeriod=3
     Mesh=SkeletalMesh'KFWeaponModels.Dualies'
     TransientSoundVolume=1.000000
     TransientSoundRadius=300.000000
     DrawScale=0.900000
     altFlashBoneName=Tip
     FlashBoneName=Tip2
     TPAnim=DualiesAttackRight;
     altTPAnim=DualiesAttackLeft;
     altWeaponAttach=Bone_weapon2

}
