//==============================================================================
//	Description
//
//	Created by Ron Prestenback
//	 2003, Epic Games, Inc.  All Rights Reserved
//==============================================================================
class KFDetailSettings extends UT2K4Tab_DetailSettings;


defaultproperties
{
    OnPreDraw=InternalOnPreDraw
    RelaunchQuestion="The graphics mode has been successfully changed.  However, it will not take effect until the next time the game is started.  Would you like to restart UT2004 right now?"
    Begin Object class=GUISectionBackground Name=sbSection1
        WinWidth=0.491849
        WinHeight=0.440729
        WinLeft=0.000948
        WinTop=0.012761
        Caption="Resolution"
        RenderWeight=0.01
    End Object
    sb_Section1=sbSection1

    Begin Object class=GUISectionBackground Name=sbSection2
        WinWidth=0.502751
        WinHeight=0.975228
        WinLeft=0.495826
        WinTop=0.012761
        Caption="Options"
        RenderWeight=0.01
    End Object
    sb_Section2=sbSection2

    Begin Object class=GUISectionBackground Name=sbSection3
        WinWidth=0.462891
        WinHeight=0.511261
        WinLeft=0.011132
        WinTop=0.476061
        Caption="Gamma Test"
        RenderWeight=0.01
        bFillClient=true
    End Object
    sb_Section3=sbSection3

    Begin Object Class=moComboBox Name=RenderDeviceCombo
        Caption="Render Device"
        ComponentJustification=TXTA_Left
        Hint="Alternate rendering devices may offer better performance on your machine."
        WinWidth=0.401953
        WinLeft=0.547773
        WinTop=0.335021
        CaptionWidth=0.55
        TabOrder=0
        bBoundToParent=True
        bScaleToParent=True
        OnLoadINI=InternalOnLoadINI
        OnChange=InternalOnChange
        IniOption="@Internal"
    End Object
    co_RenderDevice=RenderDeviceCombo

    Begin Object class=moComboBox Name=VideoResolution
        WinWidth=0.390000
        WinLeft=0.030508
        WinTop=0.060417
        Caption="Resolution"
        INIOption="@INTERNAL"
        INIDefault="640x480"
        OnLoadINI=InternalOnLoadINI
        OnChange=InternalOnChange
        Hint="Select the video resolution at which you wish to play."
        bReadOnly=true
        CaptionWidth=0.55
        bHeightFromComponent=false
        TabOrder=1
    End Object
    co_Resolution=VideoResolution

    Begin Object class=moComboBox Name=VideoColorDepth
        WinWidth=0.390000
        WinLeft=0.030234
        WinTop=0.117188
        Caption="Color Depth"
        INIOption="@Internal"
        INIDefault="false"
        OnChange=InternalOnChange
        OnLoadINI=InternalOnLoadINI
        Hint="Select the maximum number of colors to display at one time."
        CaptionWidth=0.55
        bHeightFromComponent=false
        TabOrder=2
    End Object
    co_ColorDepth=VideoColorDepth

    Begin Object class=moCheckBox Name=VideoFullScreen
        WinWidth=0.387500
        WinLeft=0.030976
        WinTop=0.169531
        Caption="Full Screen"
        INIOption="@Internal"
        INIDefault="True"
        OnLoadINI=InternalOnLoadINI
        OnChange=InternalOnChange
        Hint="Check this box to run the game full screen."
        bSquare=true
        ComponentJustification=TXTA_Left
        CaptionWidth=0.94
        TabOrder=3
    End Object
    ch_FullScreen=VideoFullScreen

    Begin Object class=moSlider Name=BrightnessSlider
        WinWidth=0.461445
        WinLeft=0.012188
        WinTop=0.229951
        MinValue=0.0
        MaxValue=1.0
        Caption="Brightness"
        CaptionWidth=0.55
        ComponentWidth=-1
        LabelJustification=TXTA_Left
        OnLoadINI=InternalOnLoadINI
        OnChange=InternalOnChange
        INIOption="@Internal"
        INIDefault="0.8"
        Hint="Use the slider to adjust the Brightness to suit your monitor."
        TabOrder=4
        bHeightFromComponent=False
        SliderCaptionStyleName=""
    End Object
    sl_Brightness=BrightnessSlider

    Begin Object class=moSlider Name=GammaSlider
        WinWidth=0.461133
        WinLeft=0.012501
        WinTop=0.272918
        MinValue=0.5
        MaxValue=2.5
        Caption="Gamma"
        CaptionWidth=0.55
        ComponentWidth=-1
        LabelJustification=TXTA_Left
        bHeightFromComponent=False
        OnLoadINI=InternalOnLoadINI
        OnChange=InternalOnChange
        INIOption="@Internal"
        INIDefault="0.8"
        Hint="Use the slider to adjust the Gamma to suit your monitor."
        TabOrder=5
        SliderCaptionStyleName=""
    End Object
    sl_Gamma=GammaSlider

    Begin Object class=moSlider Name=ContrastSlider
        WinWidth=0.461133
        WinLeft=0.012188
        WinTop=0.313285
        MinValue=0.0
        MaxValue=1.0
        Caption="Contrast"
        CaptionWidth=0.55
        ComponentWidth=-1
        bHeightFromComponent=False
        LabelJustification=TXTA_Left
        OnLoadINI=InternalOnLoadINI
        OnChange=InternalOnChange
        INIOption="@Internal"
        INIDEfault="0.8"
        Hint="Use the slider to adjust the Contrast to suit your monitor."
        TabOrder=6
        SliderCaptionStyleName=""
    End Object
    sl_Contrast=ContrastSlider

    Begin Object class=GUIImage Name=GammaBar
        WinWidth=0.456250
        WinHeight=0.532117
        WinLeft=0.013477
        WinTop=0.450001
        Image=material'2K4Menus.Controls.gamma'
        ImageColor=(R=255,G=255,B=255,A=255)
        OnChange=InternalOnChange
        ImageRenderStyle=MSTY_Normal
        ImageStyle=ISTY_Scaled
    End Object
    i_GammaBar=GammaBar

    Begin Object class=moComboBox Name=DetailTextureDetail
        WinWidth=0.400000
        WinLeft=0.550000
        WinTop=0.063021
        Caption="Texture Detail"
        INIOption="@Internal"
        INIDefault="High"
        OnLoadINI=InternalOnLoadINI
        Hint="Changes how much world detail will be rendered."
        CaptionWidth=0.65
        ComponentJustification=TXTA_Left
        TabOrder=7
        bHeightFromComponent=false
        OnChange=InternalOnChange
    End Object
    co_Texture=DetailTextureDetail

    Begin Object class=moComboBox Name=DetailCharacterDetail
        WinWidth=0.400000
        WinLeft=0.550000
        WinTop=0.116667
        Caption="Character Detail"
        INIOption="@Internal"
        INIDefault="High"
        OnLoadINI=InternalOnLoadINI
        Hint="Changes how much character detail will be rendered."
        CaptionWidth=0.65
        ComponentJustification=TXTA_Left
        TabOrder=8
        bHeightFromComponent=false
        OnChange=InternalOnChange
    End Object
    co_Char=DetailCharacterDetail

    Begin Object class=moComboBox Name=DetailWorldDetail
        WinWidth=0.400000
        WinLeft=0.550000
        WinTop=0.170312
        Caption="World Detail"
        INIOption="@Internal"
        INIDefault="High"
        OnLoadINI=InternalOnLoadINI
        Hint="Changes the level of detail used for optional geometry and effects."
        CaptionWidth=0.65
        ComponentJustification=TXTA_Left
        TabOrder=9
        bHeightFromComponent=false
        OnChange=InternalOnChange
    End Object
    co_World=DetailWorldDetail

    Begin Object class=moComboBox Name=DetailPhysics
        WinWidth=0.400000
        WinLeft=0.550000
        WinTop=0.223958
        Caption="Physics Detail"
        INIOption="@Internal"
        INIDefault="High"
        OnLoadINI=InternalOnLoadINI
        Hint="Changes the physics simulation level of detail."
        CaptionWidth=0.65
        ComponentJustification=TXTA_Left
        TabOrder=10
        OnChange=InternalOnChange
    End Object
    co_Physics=DetailPhysics

    Begin Object class=moComboBox Name=MeshLOD
        WinWidth=0.4
        WinLeft=0.55
        WinTop=0.223958
        Caption="Dynamic Mesh LOD"
        Hint="Adjusts how aggressively character and vehicle details are reduced at a distance.  Higher settings increase the distance at which details are reduced, possibly improving visual detail at a cost in performance"
        IniOption="@Internal"
        OnLoadINI=InternalOnLoadINI
        CaptionWidth=0.65
        ComponentJustification=TXTA_Left
        TabOrder=11
        OnChange=InternalOnChange
    End Object
    co_MeshLOD=MeshLOD

    Begin Object class=moComboBox Name=DetailDecalStay
        WinWidth=0.400000
        WinLeft=0.550000
        WinTop=0.282032
        Caption="Decal Stay"
        INIOption="@Internal"
        INIDefault="Normal"
        OnLoadINI=InternalOnLoadINI
        Hint="Changes how long weapon scarring effects stay around."
        CaptionWidth=0.65
        ComponentJustification=TXTA_Left
        TabOrder=12
        OnChange=InternalOnChange
    End Object
    co_Decal=DetailDecalStay

    Begin Object class=moComboBox Name=DetailCharacterShadows
        WinWidth=0.300000
        WinLeft=0.600000
        WinTop=0.431378
        Caption="Character Shadows"
        INIOption="@Internal"
        OnLoadINI=InternalOnLoadINI
        Hint="Adjust the detail of character shadows.  'Blob' or 'None' recommended for low-performance PC's"
        CaptionWidth=0.65
        ComponentJustification=TXTA_Left
        TabOrder=13
        OnChange=InternalOnChange
    End Object
    co_Shadows=DetailCharacterShadows

    Begin Object class=moCheckBox Name=DetailDecals
        WinWidth=0.300000
        WinHeight=0.040000
        WinLeft=0.600000
        WinTop=0.479308
        Caption="Decals"
        INIOption="@Internal"
        INIDefault="True"
        OnLoadINI=InternalOnLoadINI
        Hint="Enables weapon scarring effects."
        CaptionWidth=0.94
        bSquare=true
        ComponentJustification=TXTA_Left
        TabOrder=14
        OnChange=InternalOnChange
    End Object
    ch_Decals=DetailDecals

    Begin Object class=moCheckBox Name=DetailDynamicLighting
        WinWidth=0.300000
        WinHeight=0.040000
        WinLeft=0.600000
        WinTop=0.526716
        Caption="Dynamic Lighting"
        INIOption="@Internal"
        INIDefault="True"
        OnLoadINI=InternalOnLoadINI
        Hint="Enables dynamic lights."
        CaptionWidth=0.94
        bSquare=true
        ComponentJustification=TXTA_Left
        TabOrder=15
        OnChange=InternalOnChange
    End Object
    ch_DynLight=DetailDynamicLighting

    Begin Object class=moCheckBox Name=DetailDetailTextures
        WinWidth=0.300000
        WinHeight=0.040000
        WinLeft=0.600000
        WinTop=0.575425
        Caption="Detail Textures"
        INIOption="@Internal"
        INIDefault="True"
        OnLoadINI=InternalOnLoadINI
        Hint="Enables detail textures."
        CaptionWidth=0.94
        bSquare=true
        ComponentJustification=TXTA_Left
        TabOrder=16
        OnChange=InternalOnChange
    End Object
    ch_Textures=DetailDetailTextures

    Begin Object class=moCheckBox Name=DetailCoronas
        WinWidth=0.300000
        WinHeight=0.040000
        WinLeft=0.600000
        WinTop=0.624136
        Caption="Coronas"
        INIOption="@Internal"
        INIDefault="True"
        OnLoadINI=InternalOnLoadINI
        Hint="Enables coronas."
        CaptionWidth=0.94
        bSquare=true
        ComponentJustification=TXTA_Left
        TabOrder=17
        OnChange=InternalOnChange
    End Object
    ch_Coronas=DetailCoronas

    Begin Object class=moCheckBox Name=DetailTrilinear
        WinWidth=0.300000
        WinHeight=0.040000
        WinLeft=0.600000
        WinTop=0.673263
        Caption="Trilinear Filtering"
        INIOption="@Internal"
        INIDefault="False"
        OnLoadINI=InternalOnLoadINI
        Hint="Enables trilinear filtering, recommended for high-performance PCs."
        CaptionWidth=0.94
        bSquare=true
        ComponentJustification=TXTA_Left
        TabOrder=18
        OnChange=InternalOnChange
    End Object
    ch_Trilinear=DetailTrilinear

    Begin Object class=moCheckBox Name=DetailProjectors
        WinWidth=0.300000
        WinHeight=0.040000
        WinLeft=0.600000
        WinTop=0.721195
        Caption="Projectors"
        INIOption="@Internal"
        INIDefault="True"
        OnLoadINI=InternalOnLoadINI
        Hint="Enables projectors."
        CaptionWidth=0.94
        bSquare=true
        ComponentJustification=TXTA_Left
        TabOrder=19
        OnChange=InternalOnChange
    End Object
    ch_Projectors=DetailProjectors

    Begin Object class=moCheckBox Name=DetailDecoLayers
        WinWidth=0.300000
        WinHeight=0.040000
        WinLeft=0.599727
        WinTop=0.769906
        Caption="Foliage"
        INIOption="@Internal"
        INIDefault="True"
        OnLoadINI=InternalOnLoadINI
        Hint="Enables grass and other decorative foliage."
        CaptionWidth=0.94
        bSquare=true
        ComponentJustification=TXTA_Left
        TabOrder=20
        OnChange=InternalOnChange
    End Object
    ch_DecoLayers=DetailDecoLayers

    Begin Object Class=moCheckBox Name=WeatherEffects
        WinWidth=0.300000
        WinHeight=0.040000
        WinLeft=0.599727
        WinTop=0.864910
        Caption="Weather Effects"
        Hint="Enable weather effects like rain-drops and lightning."
        OnLoadINI=InternalOnLoadIni
        IniOption="@Internal"
        IniDefault="False"
        CaptionWidth=0.94
        bSquare=True
        ComponentJustification=TXTA_Left
        TabOrder=21
        OnChange=InternalOnChange
    End Object
    ch_Weather=WeatherEffects

    Begin Object Class=moSlider Name=DistanceLODSlider
        MaxValue=1.000000
        Value=0.500000
        Caption="Fog Distance"
        SliderCaptionStyleName=""
        Hint="Reduce the fog distance to improve performance."
        IniOption="@Internal"
        bAutoSizeCaption=True
        CaptionWidth=0.65
        OnLoadIni=InternalOnLoadIni
        OnChange=InternalOnChange
        WinTop=0.910000
        WinLeft=0.560000
        WinWidth=0.400000
        TabOrder=22
    End Object
    sl_DistanceLOD=DistanceLODSlider

    WinTop=0.15
    WinLeft=0
    WinWidth=1
    WinHeight=0.74
    bAcceptsInput=false

    DetailLevels(0)="Lowest"
    DetailLevels(1)="Very Low"
    DetailLevels(2)="Lower"
    DetailLevels(3)="Low"
    DetailLevels(4)="Normal"
    DetailLevels(5)="High"
    DetailLevels(6)="Higher"
    DetailLevels(7)="Very High"
    DetailLevels(8)="Highest"
    bExpert=false;

    DisplayModes(0)=(Width=320,Height=240)
    DisplayModes(1)=(Width=512,Height=384)
    DisplayModes(2)=(Width=640,Height=480)
    DisplayModes(3)=(Width=800,Height=500)
    DisplayModes(4)=(Width=800,Height=600)
    DisplayModes(5)=(Width=1024,Height=640)
    DisplayModes(6)=(Width=1024,Height=768)
    DisplayModes(7)=(Width=1152,Height=768)
    DisplayModes(8)=(Width=1152,Height=864)
    DisplayModes(9)=(Width=1280,Height=800)
    DisplayModes(10)=(Width=1280,Height=854)
    DisplayModes(11)=(Width=1280,Height=960)
    DisplayModes(12)=(Width=1280,Height=1024)
    DisplayModes(13)=(Width=1600,Height=1024)
    DisplayModes(14)=(Width=1600,Height=1200)
    DisplayModes(15)=(Width=1680,Height=1050)
    DisplayModes(16)=(Width=1920,Height=1200)

    RenderModeText(0)="Direct 3D"
    RenderModeText(1)="Software"
    RenderMode(0)="D3DDrv.D3DRenderDevice"
    RenderMode(1)="PixoDrv.PixoRenderDevice"

    BitDepthText(0)="16-bit"
    BitDepthText(1)="32-bit"

    ShadowOptions(0)="None"
    ShadowOptions(1)="Blob"
    ShadowOptions(2)="Full"

    PanelCaption="Display"
    DisplayPromptMenu="GUI2K4.UT2K4VideoChangeOK"
    InvalidSelectionText="The selected custom resolution is reported to be incompatible with your machine.  In order to ensure maximum stability, it is recommended that you choose a compatible resolution from the 'Resolution' drop-down menu"
}
