class KFGameType extends Invasion

config;

#exec OBJ LOAD FILE=KFCharacters.utx
#exec OBJ LOAD FILE=KillingFloorTextures.utx
#exec OBJ LOAD FILE=KillingFloorWeapons.utx
#exec OBJ LOAD FILE=KillingFloorManorTextures.utx
#exec OBJ LOAD FILE=KillingFloorManorTextures.utx
#exec OBJ LOAD FILE=KillingFloorHUD.utx
#exec OBJ LOAD FILE=KFX.utx
#exec OBJ LOAD FILE=KFMaterials.utx
#exec OBJ LOAD FILE=KillingFloorLabTextures.utx
#exec OBJ LOAD FILE=KillingFloorStatics.usx
#exec OBJ LOAD FILE=KillingFloorManorStatics.usx
#exec OBJ LOAD FILE=KillingFloorLabStatics.usx
#exec OBJ LOAD FILE=KFCharacterModels.ukx
#exec OBJ LOAD FILE=KFWeaponModels.ukx

var string HumanName[4];
var string ZombieName[4];
var class<KFPawn> Zombietypes[3];
var class<KFPawn> Humantypes[3];
var int ZombieChoice;
var int HumanChoice;
var int Time;

var(LoadingHints) private localized array<string> KFHints;

var bool thing;



 static function PrecacheGameTextures(LevelInfo myLevel)
{

   class'xTeamGame'.static.PrecacheGameTextures(myLevel);

   if(default.thing)
   return;

   log("PRECACHING");

   // Player precaches
   myLevel.AddPrecacheMaterial(Texture'KFCharacters.InfectedWhiteMaleSkin');
   myLevel.AddPrecacheMaterial(Texture'KFCharacters.InfectedWhiteMaleSkin2');
   myLevel.AddPrecacheMaterial(Texture'KFCharacters.InfectedBlackMaleSkin');
   myLevel.AddPrecacheMaterial(Texture'KFCharacters.InfectedWhiteFemaleSkin');
   myLevel.AddPrecacheMaterial(FinalBlend'KFCharacters.HairFinalBlend');
   myLevel.AddPrecacheMaterial(FinalBlend'KFCharacters.GasMaskFinal');
   myLevel.AddPrecacheMaterial(Texture'KFCharacters.SoldierSkin2');

   // Weapon precaches

   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.AxeTexture');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.AxeTexture3P');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.BatTex');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.ClawsSkin');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.ClawsSkin2');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.Arms1Skin');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.Glove');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.Deagle');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.Deagle3P');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.BerettaTex_HIGH');
//   myLevel.AddPrecacheMaterial(FinalBlend'KillingFloorWeapons.BerettaTex_HIGH3P');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.FragSkin');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.KnifeSkin');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.KnifeSkin3P');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.L85Cross');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.RifleTex');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.RifleTex3P');
   myLevel.AddPrecacheMaterial(Material'KillingFloorWeapons.LensFinal');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.Shotguntex');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.Shotguntex3P');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.CommandoCross');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.XbowSkin');
   myLevel.AddPrecacheMaterial(Texture'KillingFloorWeapons.XbowSkin3P');
   myLevel.AddPrecacheMaterial(Material'KillingFloorWeapons.XbowScopeFinal');

   default.thing=true;
}

 static function PrecacheGameStaticMeshes(LevelInfo myLevel)
{
   class'xTeamGame'.static.PrecacheGameStaticMeshes(myLevel);

/*   myLevel.AddPrecacheStaticMesh(StaticMesh'KillingFloorStatics.3PDeagle_Ground');
   myLevel.AddPrecacheStaticMesh(StaticMesh'KillingFloorStatics.3PFireAxe_Ground');
   myLevel.AddPrecacheStaticMesh(StaticMesh'KillingFloorStatics.3PKnife_Ground');
   myLevel.AddPrecacheStaticMesh(StaticMesh'KillingFloorStatics.3PL85_Ground');
   myLevel.AddPrecacheStaticMesh(StaticMesh'KillingFloorStatics.3PShotgun_Ground');*/
   myLevel.AddPrecacheStaticMesh(StaticMesh'KillingFloorStatics.DualiesGround');
}

static function PrecacheGameAnnouncements(AnnouncerVoice V, bool bRewardSounds)
{
    Super.PrecacheGameAnnouncements(V,bRewardSounds);
    if(!bRewardSounds)
    {
        V.PrecacheSound('HereTheyCome1');
        V.PrecacheSound('HereTheyCome2');
        V.PrecacheSound('HereTheyCome3');
    }
}



function bool PickupQuery( Pawn Other, Pickup item )
{
   local Inventory i;
   local bool haveTheGun;

   haveTheGun=false;
   if(item.IsA('KFAmmoPickup'))
   {
       for(i=Other.Inventory;i != None;i = i.Inventory)
       {
           if(Weapon(i) == None)
               continue;
           if(Weapon(i).AmmoClass[0] == item.InventoryType ||
           Weapon(i).AmmoClass[1] == item.InventoryType)
           {
               haveTheGun=true;
               break;
           }
       }
       if(!haveTheGun)
           return false;
   }
   return Super.PickupQuery(Other,item);
}

function AddMonster()
{
   local NavigationPoint StartSpot;
   local Pawn NewMonster;
   local class<Monster> NewMonsterClass;

   StartSpot = FindPlayerStart(None,1);
   if ( StartSpot == None )
       return;

   NewMonsterClass = WaveMonsterClass[Rand(WaveNumClasses)];
   NewMonster = Spawn(NewMonsterClass,,,StartSpot.Location+(NewMonsterClass.Default.CollisionHeight - StartSpot.CollisionHeight) * vect(0,0,1),StartSpot.Rotation);
   if ( NewMonster ==  None )
       NewMonster = Spawn(FallBackMonster,,,StartSpot.Location+(class'KFmod.ZombieMonster'.Default.CollisionHeight - StartSpot.CollisionHeight) * vect(0,0,1),StartSpot.Rotation);
   if ( NewMonster != None )
   {
       WaveMonsters++;
       NumMonsters++;
   }
}


function RestartPlayer( Controller aPlayer )
{
   aPlayer.PawnClass=Humantypes[rand(3)];
   Super.RestartPlayer(aPlayer);
}

function bool CheckMaxLives(PlayerReplicationInfo Scorer)
{
   local Controller C;
   local PlayerReplicationInfo Living;
   local bool bNoneLeft;

   if ( MaxLives > 0 )
   {
       bNoneLeft = true;
       for ( C=Level.ControllerList; C!=None; C=C.NextController )
           if ( (C.PlayerReplicationInfo != None) && C.bIsPlayer
               && !C.PlayerReplicationInfo.bOutOfLives
               && !C.PlayerReplicationInfo.bOnlySpectator )
           {
               bNoneLeft = false;
               break;
           }
       if ( bNoneLeft )
       {
           if ( Living != None )
               EndGame(Living,"LastMan");
           else
               EndGame(Scorer,"LastMan");
           return true;
       }
   }
   return false;
}

function ScoreKill(Controller Killer, Controller Other)
{
   local PlayerReplicationInfo OtherPRI;
   local float KillScore;

   OtherPRI = Other.PlayerReplicationInfo;
   if ( OtherPRI != None )
   {
       OtherPRI.NumLives++;
       OtherPRI.Score -= 10;
       OtherPRI.Team.Score -= 10;
       OtherPRI.Team.NetUpdateTime = Level.TimeSeconds - 1;
       OtherPRI.bOutOfLives = true;
       BroadcastLocalizedMessage(class'KFMod.KFInvasionMessage', 1, OtherPRI);
       CheckScore(None);
   }

   if ( GameRulesModifiers != None )
       GameRulesModifiers.ScoreKill(Killer, Other);

   if ( MonsterController(Killer) != None )
       return;

   if( (killer == Other) || (killer == None) )
   {
       if ( Other.PlayerReplicationInfo != None )
       {
           Other.PlayerReplicationInfo.Score -= 1;
           Other.PlayerReplicationInfo.NetUpdateTime = Level.TimeSeconds - 1;
           Killer.PlayerReplicationInfo.Team.Score -= 1;
           Killer.PlayerReplicationInfo.Team.NetUpdateTime = Level.TimeSeconds - 1;
           ScoreEvent(Other.PlayerReplicationInfo,-1,"self_frag");
       }
   }

   if ( (Killer == None) || !Killer.bIsPlayer || (Killer == Other) )
       return;

   if ( Other.bIsPlayer )
   {
       Killer.PlayerReplicationInfo.Score -= 10;
       Killer.PlayerReplicationInfo.NetUpdateTime = Level.TimeSeconds - 1;
       Killer.PlayerReplicationInfo.Team.Score -= 10;
       Killer.PlayerReplicationInfo.Team.NetUpdateTime = Level.TimeSeconds - 1;
       ScoreEvent(Killer.PlayerReplicationInfo, -10, "team_frag");
       return;
   }
   if ( LastKilledMonsterClass == None )
       KillScore = 1;
   else
       KillScore = LastKilledMonsterClass.Default.ScoringValue;
   Killer.PlayerReplicationInfo.Kills++;
   Killer.PlayerReplicationInfo.Score += KillScore;
   Killer.PlayerReplicationInfo.Team.Score += KillScore;
   Killer.PlayerReplicationInfo.Team.NetUpdateTime = Level.TimeSeconds - 1;
   Killer.PlayerReplicationInfo.NetUpdateTime = Level.TimeSeconds - 1;
   TeamScoreEvent(Killer.PlayerReplicationInfo.Team.TeamIndex, 1, "tdm_frag");
}

function Bot SpawnBot(optional string botName)
{
   local Bot NewBot;
   local RosterEntry Chosen;
   local UnrealTeamInfo BotTeam;
   local int which;

   BotTeam = GetBotTeam();

   which=rand(4);

   botName=HumanName[which];
   if(BotTeam.TeamIndex==1)
       botName=ZombieName[which];

   Chosen = BotTeam.ChooseBotClass(botName);

   which = rand(3);
   Chosen.PawnClass=Humantypes[which];

   if (Chosen.PawnClass == None)
       Chosen.Init(); //amb

   NewBot = Bot(Spawn(Chosen.PawnClass.default.ControllerClass));

   if ( NewBot != None )
       InitializeBot(NewBot,BotTeam,Chosen);

   NewBot.SetPawnClass(string(Chosen.PawnClass),"Soldier");


   return NewBot;

   if(BotTeam.TeamIndex==1)
       {
       botName=ZombieName[which];
       }else
       {
       botName=HumanName[which];
       }

   Chosen.PlayerName=BotName;



}

function ReplenishWeapons(Pawn P)
{

}


// Play The Warning Sound at the Beginning of the Match

function WarningTimer()
{

    if (Level.TimeSeconds >= Time &&  bWaveInProgress == true )
    {

            //PlaySound(sound'KFPlayerSound.HereTheyCome2', SLOT_Misc,255, ,10000);
            Time += 90;
    }
}


function Timer()
{
   Super.Timer();
   WarningTimer();
}


// Experimental

State MatchInProgress
{
   function Timer()
   {
       local Controller C;
       local bool bOneMessage;
       local Bot B;
       local int PlayerCount;

       Super(xTeamGame).Timer();
       if ( bWaveInProgress )
       {
           if ( (WaveEndTime - Level.TimeSeconds < 30) && (MaxMonsters < Waves[WaveNum].WaveMaxMonsters) )
           {
               for ( C = Level.ControllerList; C != None; C = C.NextController )
                   if ( C.bIsPlayer && (C.Pawn != None) )
                       PlayerCount++;
               if ( PlayerCount > 1 )
                   MaxMonsters = Waves[WaveNum].WaveMaxMonsters;
           }
           if ( (Level.TimeSeconds > WaveEndTime) && (WaveMonsters >= 2*MaxMonsters) )
           {
               if ( Level.TimeSeconds > WaveEndTime + 90 )
               {
                   for ( C = Level.ControllerList; C != None; C = C.NextController )
                       if ( (MonsterController(C) != None) && (Level.TimeSeconds - MonsterController(C).LastSeenTime > 30)
                           && !MonsterController(C).Pawn.PlayerCanSeeMe() )
                       {
                           C.Pawn.KilledBy( C.Pawn );
                           return;
                       }
               }
               if ( NumMonsters <= 0 )
               {
                   bWaveInProgress = false;
                   WaveCountDown = 7;
                   WaveNum++;
               }
           }
           else if ( (Level.TimeSeconds > NextMonsterTime) && (NumMonsters < MaxMonsters) )
           {
               AddMonster();
               if ( NumMonsters < 1.5 * (NumPlayers + NumBots) )
                   NextMonsterTime = Level.TimeSeconds + 0.2;
               else
                   NextMonsterTime = Level.TimeSeconds + 2;
           }
       }
       else if ( NumMonsters <= 0 )
       {
           if ( WaveNum == FinalWave )
           {
               EndGame(None,"TimeLimit");
               return;
           }
           WaveCountDown--;
           if ( WaveCountDown == 6 )
           {
               for ( C = Level.ControllerList; C != None; C = C.NextController )
               {
                   if ( C.PlayerReplicationInfo != None )
                   {
                       C.PlayerReplicationInfo.bOutOfLives = false;
                       C.PlayerReplicationInfo.NumLives = 0;
                       if ( C.Pawn != None )
                           ReplenishWeapons(C.Pawn);
                       else if ( !C.PlayerReplicationInfo.bOnlySpectator && (PlayerController(C) != None) )
                           C.GotoState('PlayerWaiting');
                   }
               }
           }
           if ( WaveCountDown == 5 )
           {
               InvasionGameReplicationInfo(GameReplicationInfo).WaveNumber = WaveNum;
               for ( C = Level.ControllerList; C != None; C = C.NextController )
               {
                   if ( PlayerController(C) != None )
                   {
                       if ( (C.Pawn == None) && !C.PlayerReplicationInfo.bOnlySpectator )
                           PlayerController(C).SetViewTarget(C);
                   }
                   if ( C.PlayerReplicationInfo != None )
                   {
                       C.PlayerReplicationInfo.bOutOfLives = false;
                       C.PlayerReplicationInfo.NumLives = 0;
                       if ( (C.Pawn == None) && !C.PlayerReplicationInfo.bOnlySpectator )
                           C.ServerReStartPlayer();
                   }
               }
           }
           else if ( (WaveCountDown > 0) && (WaveCountDown < 5) )
               BroadcastLocalizedMessage(class'KFMod.WaitingMessage', WaveCountDown-1);
           else if ( WaveCountDown <= 1 )
           {
               bWaveInProgress = true;
               SetupWave();
               for ( C = Level.ControllerList; C != None; C = C.NextController )
                   if ( PlayerController(C) != None )
                       PlayerController(C).LastPlaySpeech = 0;
               for ( C = Level.ControllerList; C != None; C = C.NextController )
                   if ( Bot(C) != None )
                   {
                       B = Bot(C);
                       InvasionBot(B).bDamagedMessage = false;
                       B.bInitLifeMessage = false;
                       if ( !bOneMessage && (FRand() < 0.65) )
                       {
                           bOneMessage = true;
                           if ( (B.Squad.SquadLeader != None) && B.Squad.CloseToLeader(C.Pawn) )
                           {
                               B.SendMessage(B.Squad.SquadLeader.PlayerReplicationInfo, 'OTHER', B.GetMessageIndex('INPOSITION'), 20, 'TEAM');
                               B.bInitLifeMessage = false;
                           }
                       }
                   }
           }
       }
   }

   function BeginState()
   {
       Super.BeginState();
       WaveNum = InitialWave;
       InvasionGameReplicationInfo(GameReplicationInfo).WaveNumber = WaveNum;
   }
}



//after putzing around with pawnclass (genders) let's rename them right..
//if(which>=2)
//  {
//and teams get different names, why the f not?

 // if(BotTeam.TeamIndex==0) //alien
 //   S = ZombieName[ZombieNameOffset%4];
//  else
//    S = ZombieName[ZombieNameOffset%4];
//  ZombieNameOffset++;
//  ChangeName(NewBot,S, false);
 // }else
 // {
//and teams get different names, why the f not?

  //if(BotTeam.TeamIndex==0) //alien
  //   S = ZombieName[ZombieNameOffset%4];
 // else
//     S = ZombieName[ZombieNameOffset%4];
//  ZombieNameOffset++;
//  ChangeName(NewBot,S, false);
 // }



event InitGame( string Options, out string Error )
{
   Super.InitGame(Options, Error);

   FallbackMonster = class<Monster>(DynamicLoadObject(FallbackMonsterClass, class'Class'));
   if (FallbackMonster == None)
       FallbackMonster = class'KFMod.ZombieMonster';
   MaxLives = 1;
   bForceRespawn = true;
}

static function array<string> GetAllLoadHints(optional bool bThisClassOnly)
{
	return default.KFHints;
}

function PlayStartupMessage()
{
}

//This is kinda messy, but we need to get rid of those damned blue
//messages.
event PostLogin( PlayerController NewPlayer )
{
    Super(UnrealMPGameInfo).PostLogin(NewPlayer);
	if (UnrealPlayer(NewPlayer) != None)
		UnrealPlayer(NewPlayer).ClientReceiveLoginMenu(LoginMenuClass, bAlwaysShowLoginMenu);
	if ( NewPlayer.PlayerReplicationInfo.Team != None )
		GameEvent("TeamChange",""$NewPlayer.PlayerReplicationInfo.Team.TeamIndex,NewPlayer.PlayerReplicationInfo);
}

defaultproperties
{
    HumanName(0)="Cpl.McinTyre"
    HumanName(1)="Sgt.Michaels"
    HumanName(2)="Pvt.Davin"
    HumanName(3)="Cpl.Powers"
   // ZombieName(0)="Infected"
   // ZombieName(1)="Infected"
   // ZombieName(2)="Infected"
  //  ZombieName(3)="Infected"
   // Zombietypes(0)=Class'KFmod.KFZombiePawn'
   // Zombietypes(1)=Class'KFmod.KFZombieLightPawn'
  //  Zombietypes(2)=Class'KFmod.KFZombieHeavyPawn'
    Humantypes(0)=Class'KFmod.KFHumanPawn'
    Humantypes(1)=Class'KFmod.KFHumanPawn'
    Humantypes(2)=Class'KFmod.KFHumanPawn'

    KFHints(0)="We ran about seven kilometers that night before setting up camp in a convenience store. All I could hear outside was howling and the wet slap of many feet on the pavement."
    KFHints(1)="I saw one of them take a shotgun blast to the face and he still kept coming...Someone with a science degree had better study this shit.  "
    KFHints(2)="The 50 cal ripped through them like a hot knife through butter..at first. They somehow found a way to circumvent the blockade and circle around. We lost Barry, and the Nest, but god...the amount of blood on the shop front windows...on the road.   "
    KFHints(3)="Dave didn't make it. I couldn't even see what it was that had him because it was too dark to separate his attacker from the shadows in the alley. Almost like it *was* one of em'"
    KFHints(4)="They just spilled over the barbed wire...hundreds of them. The ones that got stuck would rip away their flesh to untangle themselves..."
    KFHints(5)="I feel as if something snapped in my head when i had to bring down one of them yesterday....a girl. She couldn't have been older than seventeen... She ran like a bat out of hell.. Gore was pouring out of her mouth. It's us or them now, ethics don't exist. I just keep telling myself that. "
    KFHints(6)="It took us almost a half hour to bring down this big ugly son of a bitch that was plodding toward the Police Station. The bullets were hitting him alright, but it was difficult to say whether they were damaging him or making him a studded jacket."
    KFHints(7)="We're running low on rations. Our next meal may be from the beat up local at the end of the street. We can see the Clerk roaming around just outside...howling and coughing up blood.
    KFHints(8)="The Soldiers said they killed my mum because if they didn't, she would bite me. They said she would bite other people as well. She never used to do that.
    KFHints(9)="By the time we arrived at the source of the radio signal, the building was empty. Someone had left a bloodstained jacket on the floor.
    KFHints(10)="We don't know a whole lot about these sons of bitches. They have basic motor functionality and are resistant to gunfire. They sustain themselves by feeding on warm flesh. Everything else is speculation."
    KFHints(11)="I told him reach the rest of his squad down Fourth Street .... That was an hour ago, where the fuck are they?! "
    KFHints(12)="The Bullpup provides steady fire support with decent stopping power, it's going to be your mainstay out there fellas. "
    KFHints(13)="They didn't notice the Frag rolling toward them, or didn't care.  The whole street was caked in entrails and burning limbs... "
    KFHints(14)="This is FireTeam Delta, we have made contact with the hostiles. Tac. Recon estimates somewhere in the range of 400-500 bodies in this area."
    FriendlyFireScale=0.000000
    NetWait=10
    SpawnProtectionTime=0.000000
    DefaultPlayerClassName="KFmod.KFHumanPawn"
    HUDType="KFmod.HUDKillingFloor"
    MapPrefix="KF"
    BeaconName="KF"
    ResetTimeDelay=10
    MutatorClass="KFmod.KillingFloorMut"
    GameReplicationInfoClass=Class'KFmod.KFGameReplicationInfo'
    GameName="Killing Floor"
    Description="They are coming. There's nothing but you and your squad standing between a writhing wall of Undead, and the scattered survivors of the Infection."
    FallbackMonsterClass="KFMod.ZombieMonster"

    InvasionBotNames(1)="Zombie"
    InvasionBotNames(2)="Zombie"
    InvasionBotNames(3)="Zombie"
    InvasionBotNames(4)="Zombie"
    InvasionBotNames(5)="Zombie"
    InvasionBotNames(6)="Zombie"
    InvasionBotNames(7)="Zombie"
    InvasionBotNames(8)="Zombie"

   MonsterClass(0)=class'KFmod.ZombieMonster'
   MonsterClass(1)=class'KFmod.ZombieMonster'
   MonsterClass(2)=class'KFmod.ZombieMonster'
   MonsterClass(3)=class'KFmod.ZombieMonster2'
   MonsterClass(4)=class'KFmod.ZombieMonster2'
   MonsterClass(5)=class'KFmod.ZombieMonster2'
   MonsterClass(6)=class'KFmod.ZombieMonster3'
   MonsterClass(7)=class'KFmod.ZombieMonster3'
   MonsterClass(8)=class'KFmod.ZombieMonster3'
   MonsterClass(9)=class'KFmod.ZombieMonster4'
   MonsterClass(10)=class'KFmod.ZombieMonster4'
   MonsterClass(11)=class'KFmod.ZombieMonster4'
   MonsterClass(12)=class'KFmod.ZombieBoss'
   MonsterClass(13)=class'KFmod.ZombieBoss'
   MonsterClass(14)=class'KFmod.ZombieMonster'
   MonsterClass(15)=class'KFmod.ZombieMonster'

   LoginMenuClass="KFMod.KFInvasionLoginMenu"


   Waves(0)=(WaveMask=571,WaveMaxMonsters=10,WaveDuration=90,WaveDifficulty=0.0)
   Waves(1)=(WaveMask=521,WaveMaxMonsters=15,WaveDuration=90,WaveDifficulty=0.0)
   Waves(2)=(WaveMask=577,WaveMaxMonsters=15,WaveDuration=90,WaveDifficulty=0.0)
   Waves(3)=(WaveMask=8182,WaveMaxMonsters=10,WaveDuration=90,WaveDifficulty=0.5)
   Waves(4)=(WaveMask=14272,WaveMaxMonsters=10,WaveDuration=90,WaveDifficulty=0.5)

    Acronym="KF"
    DeathMessageClass=class'KFMod.KFDeathMessage'
    MaxTeamSize=4
    DefaultPlayerName="Fresh Meat"
    bAllowWeaponThrowing=false
    MaxLives=1
    DefaultMaxLives=1
    NumRounds=5

    InvasionEnd(0)=Sound'KFPlayerSound.FallBack'
    InvasionEnd(1)=Sound'KFPlayerSound.FallBack'
    InvasionEnd(2)=Sound'KFPlayerSound.FallBack'
    InvasionEnd(3)=Sound'KFPlayerSound.FallBack'
    InvasionEnd(4)=Sound'KFPlayerSound.FallBack'
    InvasionEnd(5)=Sound'KFPlayerSound.FallBack'

   EndGameSoundName[0]=Sound'KFPlayerSound.FallBack'
   EndGameSoundName[1]=Sound'KFPlayerSound.FallBack'
   AltEndGameSoundName[0]=Sound'KFPlayerSound.FallBack'
   AltEndGameSoundName[1]=Sound'KFPlayerSound.FallBack'
   ScoreBoardType="KFmod.KFScoreBoard"
   ScreenShotName="KFThumbs.KFShots"
   thing=false;
   finalwave=4;
}


