//=============================================================================
// KFPawn
//=============================================================================
class KFHumanPawn extends KFPawn;

#exec OBJ LOAD FILE=KFCharacters.utx
#exec OBJ LOAD FILE=KFSoldiers.ukx
var Emitter Blood;
var Sound BreathingSound;
//var int BreathingTime;
var Sound MiscSound; //So I can get the damn thing to shutup if the players dead.

var MotionBlur myHitBlur;
var bool bUsingHitBlur;
var float StopBlurTime;


event PreBeginPlay()
{
    SetTimer(1.5,true);
    myHitBlur = new class'MotionBlur';
    myHitBlur.BlurAlpha = 1;
    bUsingHitBlur = false;
}


function Timer()
{
        local PlayerController PC;
        PC = PlayerController(Controller);
        if(PC != None)
        {
            if(bUsingHitBlur && Level.TimeSeconds >= StopBlurTime)
            {
                PC.StopViewShaking();
                PC.RemoveCameraEffect(myHitBlur);
                bUsingHitBlur = false;
            }
        }

		if (Health <= 0)
        {
            PlaySound(MiscSound,SLOT_Talk);
            return;
        }
        if ( Health < HealthMax/2 )
        {
            PlaySound(BreathingSound, SLOT_Talk, ((50-Health)/5)*TransientSoundVolume,,TransientSoundRadius,, false);
        }

        groundspeed = FMax(140,Health*2.3);
}

function TakeDamage(int Damage, Pawn instigatedBy, Vector hitlocation, Vector momentum, class<DamageType> damageType)
{
    local PlayerController lPC;

    Super.TakeDamage(Damage,instigatedBy,hitlocation,momentum,damageType);
    if(damageType != class'MeleeDamage')
        return;
    if(Controller == None || PlayerController(Controller) == None)
        return;
    if(Controller.bGodMode)
        return;
    lPC = PlayerController(Controller);
    StopBlurTime = Level.TimeSeconds+3;
    if(!bUsingHitBlur)
    {
        lPC.AddCameraEffect(myHitBlur,false);
        bUsingHitBlur = true;
    }

    lPC.ShakeView( 6000 * Normal(vector(rotator(Momentum))),
               15000 * Normal(vector(rotator(Momentum))),
               2.0,
               60 * (Normal(Momentum)/30),
               vect(1,1,1)/200,
               1);
}

defaultproperties
{
     BreathingSound=Sound'KFPlayerSound.Malebreath'
     bCanDodgeDoubleJump=False
     MultiJumpRemaining=0
     MaxMultiJump=0
     bCanDoubleJump=False
     bCanWallDodge=False
     GroundSpeed=230.000000
     WaterSpeed=200.000000
     AirSpeed=230.000000
     JumpZ=325.000000
     Mesh=Skeletalmesh'KFSoldiers.Soldier'
     Skins(0)=Texture'KFCharacters.SoldierSkin2'
     Skins(1)=FinalBlend'KFCharacters.GasMaskFinal'
     Skins(2)=Texture'KFCharacters.SoldierSkin2'
     RequiredEquipment(0)="KFmod.Knife"
     RequiredEquipment(1)="KFmod.Dualies"
     RequiredEquipment(2)="KFmod.L85"
      ControllerClass=class'KFMod.KFInvasionBot'
}
