class KFMeleeGun extends Shieldgun ;

var name TPAnim;

function FireHack(byte Mode)
{
    if ( Mode == 0 )
    {
        FireMode[0].PlayFiring();
        IncrementFlashCount(0);
    }
}

simulated function DisplayDebug(Canvas Canvas, out float YL, out float YPos)
{
    local int i;
    local string T;
    local name Anim;
    local float frame,rate;

    Canvas.SetDrawColor(0,255,0);
    if ( (Pawn(Owner) != None) && (Pawn(Owner).PlayerReplicationInfo != None) )
        Canvas.DrawText("WEAPON "$GetItemName(string(self))$" Owner "$Pawn(Owner).PlayerReplicationInfo.PlayerName);
    else
        Canvas.DrawText("WEAPON "$GetItemName(string(self))$" Owner "$Owner);
    YPos += YL;
    Canvas.SetPos(4,YPos);

    T = "     STATE: "$GetStateName()$" Timer: "$TimerCounter$" Client State ";

    Switch( ClientState )
    {
        case WS_None: T=T$"None"; break;
        case WS_Hidden: T=T$"Hidden"; break;
        case WS_BringUp: T=T$"BringUp"; break;
        case WS_PutDown: T=T$"PutDown"; break;
        case WS_ReadyToFire: T=T$"ReadyToFire"; break;
    }

    Canvas.DrawText(T, false);
    YPos += YL;
    Canvas.SetPos(4,YPos);

    if ( DrawType == DT_StaticMesh )
        Canvas.DrawText("     StaticMesh "$GetItemName(string(StaticMesh))$" AmbientSound "$AmbientSound, false);
    else
        Canvas.DrawText("     Mesh "$GetItemName(string(Mesh))$" AmbientSound "$AmbientSound, false);
    YPos += YL;
    Canvas.SetPos(4,YPos);
    if ( Mesh != None )
    {
        // mesh animation
        GetAnimParams(0,Anim,frame,rate);
        T = "     AnimSequence "$Anim$" Frame "$frame$" Rate "$rate;
        if ( bAnimByOwner )
            T= T$" Anim by Owner";

        Canvas.DrawText(T, false);
        YPos += YL;
        Canvas.SetPos(4,YPos);

        T = "Eyeheight "$Instigator.EyeHeight$" base "$Instigator.BaseEyeheight$" landbob "$Instigator.Landbob$" just landed "$Instigator.bJustLanded$" land recover "$Instigator.bLandRecovery;
        Canvas.DrawText(T, false);
        YPos += YL;
        Canvas.SetPos(4,YPos);
    }

    for ( i=0; i<NUM_FIRE_MODES; i++ )
    {
        if ( FireMode[i] == None )
        {
            Canvas.DrawText("NO FIREMODE "$i);
            YPos += YL;
            Canvas.SetPos(4,YPos);
        }
        else
            FireMode[i].DisplayDebug(Canvas,YL,YPos);

        YPos += YL;
        Canvas.SetPos(4,YPos);
    }
}


function DoReflectEffect(int Drain)
{

}


function AnimEnd(int channel)
{
    if (FireMode[0].bIsFiring)
    {
        LoopAnim('MeleeAttack');
    }

    if (FireMode[1].bIsFiring)
    {
        LoopAnim('MeleeAttack');
    }

    else if (!FireMode[0].bIsFiring)
    {
        Super.AnimEnd(channel);
    }
}



function byte BestMode()
{
    return 0;
}

defaultproperties
{

bShowChargingBar=false
bMeleeWeapon=true
TPAnim=MeleeAttack

}

